setlocal enabledelayedexpansion

set backupdrive=
set systemdrive=d
set systemdisk=-1
set backupformated=0
set backuppartidx=1
set syspartidx=2
set needformat=0

set SYS_VOL_ID_P1=E0263075
set SYS_VOL_ID_P2=2630-4EB2 
set BKP_VOL_ID=2C2D-8E2E
set MY_PATH=%~d0%~p0
set MY_TEE=%MY_PATH%wtee.exe

call :FindSystemAndBackupDrive backupdrive systemdrive systemdisk syspartidx backuppartidx backupformated needformat

if %systemdisk%==-1 (
	@call :Print Could not find system disk, aborted!
	goto :eof
)

REM output the content of reach disk
echo System drive content...
dir /A %systemdrive%:\ 2>&1

echo Backup drive content...
dir /A %backupdrive%:\ 2>&1

echo License Dir content...
dir /A %backupdrive%:\VIVOTEK 2>&1

if exist %backupdrive%:\VIVOTEK\NetworkAdapterList.ini (
	echo NetworkAdapterList.ini content...
	type %backupdrive%:\VIVOTEK\NetworkAdapterList.ini
)

if exist %backupdrive%:\VIVOTEK\updateguid.bat (
	echo updateguid.bat content...
	type %backupdrive%:\VIVOTEK\updateguid.bat
)

if exist %backupdrive%:\menu.lst (
	echo menu.lst content
	type %backupdrive%:\menu.lst
)

if exist %MY_PATH%smartctl.exe (
	echo smartctl result...
	%MY_PATH%smartctl.exe -a /dev/hda 2>&1
)

echo.
echo.

REM we know which drive letter for system and backup now
REM so, first, set active drive back to system
@call :Print Ensure the system driver is keeping active!

set diskpart_cmd_file=%TEMP%\diskpart_1.scr
set diskpart_out_file=%TEMP%\diskpart_out.txt

echo. > %diskpart_cmd_file%
echo select disk %systemdisk% >> %diskpart_cmd_file%
echo select partition %syspartidx% >> %diskpart_cmd_file%
echo active >> %diskpart_cmd_file%
call diskpart < %diskpart_cmd_file% >nul 2>&1

REM nothing means echo.
@call :Print

set BOOTMGR=bootmgr

attrib -s -h -r %backupdrive%:\%BOOTMGR% 2>&1
REM remove the bootmgr in backup drive if any
if exist %backupdrive%:\%BOOTMGR% (
	attrib -s -h -r %backupdrive%:\%BOOTMGR%
	del /F/Q %backupdrive%:\%BOOTMGR% 2>&1
	@call :Print This machine has BCD booting error, cleared!
	@call :Print
)

REM fix the assignDosLetter.txt and removeDosLetter.txt error
set ASSIGN_DOS="%systemdrive%:\Program Files (x86)\VIVOTEK Inc\VAST\Server\Utility\SystemManager\assignDosLetter.txt"
echo select disk=system > %ASSIGN_DOS%
echo select partition 1 >> %ASSIGN_DOS%
echo set id=0C override >> %ASSIGN_DOS%
echo assign letter=Z>> %ASSIGN_DOS%
echo exit>> %ASSIGN_DOS%

set REMOVE_DOS="%systemdrive%:\Program Files (x86)\VIVOTEK Inc\VAST\Server\Utility\SystemManager\removeDosLetter.txt"
echo select disk=system > %REMOVE_DOS%
echo select partition 1 >> %REMOVE_DOS%
echo remove letter=Z >> %REMOVE_DOS%
echo set id=17 override >> %REMOVE_DOS%
echo exit >> %REMOVE_DOS%

CD /D %MY_PATH%
set SOURCE_DIR=
set DIR_ONLY=

REM if there is full image, we will do full update for backup drive
call :CheckCorrectNVRVer CorrectNVR96 SOURCE_DIR 
if [%SOURCE_DIR%]==[] call :CheckCorrectNVRVer CorrectNVR SOURCE_DIR

if NOT [%SOURCE_DIR%]==[] goto :_FullRescure


REM when being here, it means we run in light recovering mode
if %backupformated%==1 (
	@call :Print The backup partition seems to be formated, you need to get to full set of repairing USB image to recover it
	goto :_End_Of_Rescure
)

if NOT exist %backupdrive%:\grldr (
	@call :Print The backup partition content is modified, you need to get to full set of repairing USB image to recover it
	goto :_End_Of_Rescure
)

REM when here, only partial rescure is needed
if exist .\menu.lst (
	if exist .\mypostrun set SOURCE_DIR=.
)

REM only recover menu.lst
if NOT [%SOURCE_DIR%]==[] (
	@call :Print Fixing the restore to default problem...
	copy /Y %SOURCE_DIR%\menu.lst %backupdrive%:\ 2>&1
	copy /Y %SOURCE_DIR%\mypostrun %backupdrive%:\ 2>&1
	@call :Print Done.
	@call :Print
)

goto :_End_Of_Rescure

:_FullRescure
call :FixBackupDriveContent %SOURCE_DIR% %backupdrive% %backuppartidx% %needformat%

set MD5_PATH=%SOURCE_DIR%

if /I %windir%==X:\Windows (
	call :CopyVASTRegistry %systemdrive% %backupdrive%
)

if exist %MD5_PATH%\md5.exe (
	@call :Print Recovering the license data..
	call :RecoverLicense %MD5_PATH% %backupdrive% %systemdrive%
) ELSE (
	@call :Print Not able to recover license because can not find md5.exe!
	@call :Print
)

:_End_Of_Rescure
REM hide backup drive
echo. > %diskpart_cmd_file%
echo select disk %systemdisk% >> %diskpart_cmd_file%
echo select partition %backuppartidx% >> %diskpart_cmd_file%
echo remove letter=%backupdrive% >> %diskpart_cmd_file%
echo set id=17 >> %diskpart_cmd_file%
call diskpart < %diskpart_cmd_file% > nul 2>&1

@call :Print
@call :Print End of recovering process!

goto :eof

:CopyVASTRegistry
 IF EXIST "%PROGRAMFILES(X86)%" (
	set "PROGRAM_FILES_X86=Program Files (x86)"
	set VAST_REGISTRY_ROOT=HKLM\Software\Wow6432Node\VIVOTEK, Inc.\VAST
 ) ELSE (
	set PROGRAM_FILES_X86=Program Files
	set VAST_REGISTRY_ROOT=HKLM\Software\VIVOTEK, Inc.\VAST
 )

 set NODE_NAME=Wow6432Node\VIVOTEK, Inc.\VAST
 set ROOT_NAME_FAKE=HKLM\SOFTMP

 reg load "!ROOT_NAME_FAKE!" "%systemdrive%:\Windows\System32\config\SOFTWARE" >nul
 reg copy "!ROOT_NAME_FAKE!\!NODE_NAME!" "%VAST_REGISTRY_ROOT%" /s /f
 reg unload "!ROOT_NAME_FAKE!" >nul
 exit /b


:FixBackupDriveContent
 set _source_path=%1
 set _bkp_path=%2
 set _bkp_part_idx=%3
 set _needformat=%4
 
 @call :Print Fix the whole backup drive....
 if %_needformat%==1 (
	@call :Print Need to reformat the backup partition...
	echo. > %diskpart_cmd_file%
	echo select disk %systemdisk% >> %diskpart_cmd_file%
	echo select partition %_bkp_part_idx% >> %diskpart_cmd_file%
	echo format fs=FAT32 quick label="Backup" >> %diskpart_cmd_file%
	call diskpart < %diskpart_cmd_file% > nul 2>&1
	@call :Print Done.
 )
 
 REM the z drive is accidently formated, so we need to recover it
 REM in such case, we could copy everything to backup drive
 set exclide_file=%TEMP%\__exclude.tmp

 echo. > %exclide_file%
 echo modifyvolumeid.exe >> %exclide_file%
 echo image.zip >> %exclide_file%
 echo unzip.exe >> %exclide_file%
 echo md5.exe >> %exclide_file%

 @call :Print Copying the files...
 xcopy /exclude:%exclide_file% %_source_path%\*.* /s %_bkp_path%:\ /Y 2>&1
 
 @call :Print Extrat files to backup disk...
 %_source_path%\unzip -q -o %_source_path%\image.zip -d %_bkp_path%:\ 2>&1
 
 REM we need to recover the volume id if formated
 REM set could not be inside if, so we do it outside
 set _vol_id=%BKP_VOL_ID:-=%
 if %4==1 (
	CD /D %MY_PATH%
	%_source_path%\modifyvolumeid.exe %_bkp_path% %_vol_id% 2>&1
 )
 @call :Print Backup drive recovered!
 @call :Print

 exit /b
 
:RecoverLicense
 set SOURCE_PATH1=%1
 set BKP_PATH1=%2
 set SYS_DRIVE1=%3

 IF EXIST "%PROGRAMFILES(X86)%" (
	set "PROGRAM_FILES_X86=Program Files (x86)"
	set VAST_REGISTRY_ROOT=HKLM\Software\Wow6432Node\VIVOTEK, Inc.\VAST
 ) ELSE (
	set PROGRAM_FILES_X86=Program Files
	set VAST_REGISTRY_ROOT=HKLM\Software\VIVOTEK, Inc.\VAST
 )

 set MODEL_NAME=NR9681
 FOR /F "tokens=3" %%A IN ('reg query "%VAST_REGISTRY_ROOT%" /v Model') DO (
  	if NOT [%%A]==[] set MODEL_NAME=%%A
 )
 
 REM and we need to recover the license and guid of the system from system drive
 if NOT exist %BKP_PATH1%:\VIVOTEK mkdir %BKP_PATH1%:\VIVOTEK
 set BACKUP_DIR=%BKP_PATH1%:\VIVOTEK
 set PROGRAM_FILES_X86="Program Files (x86)"
 set PROGRAM_FILES_X86=%PROGRAM_FILES_X86:"=%
 set VAST_DIR="%SYS_DRIVE1%:\%PROGRAM_FILES_X86%\VIVOTEK Inc\VAST"
 set VAST_DIR=%VAST_DIR:"=%
 set VAST_SERVER_DIR="%VAST_DIR%\Server"
 set VAST_SERVER_DIR=%VAST_SERVER_DIR:"=%
 set VAST_SM_DIR=%VAST_SERVER_DIR%\Utility\SystemManager

 CD /D "%VAST_SERVER_DIR%"
 if NOT exist %BACKUP_DIR%\NetworkAdapterList.ini COPY "%VAST_SM_DIR%\NetworkAdapterList.ini" %BACKUP_DIR% /Y
 if NOT exist %BACKUP_DIR%\License.dat (
	if exist "%VAST_SERVER_DIR%\License.dat" (
		COPY "%VAST_SERVER_DIR%\License.dat" %BACKUP_DIR% /Y
	) ELSE (
		@call :Print 
		@call :Print #### There is no license file on your system... ####
		@call :Print You need to call VIVOTEK FAE to regenerate the license...
		@call :Print 
	)
 )
 
 REM always update the model name when update guid
 set NODE_NAME=Wow6432Node\VIVOTEK, Inc.\VAST
 set ROOT_NAME=HKLM\SOFTWARE
 set UPD_GUID=%BACKUP_DIR%\updateguid.bat
 set MUST_ADD_REG=0
 
 if exist %BACKUP_DIR%\updateguid.bat (
	for /F "tokens=1-6" %%a in ('type %BACKUP_DIR%\updateguid.bat ^| find /c "REG ADD"') do set MUST_ADD_REG=%%a
	if !MUST_ADD_REG!==0 (
		ren %UPD_GUID% updateguid1.bat
		echo REG ADD "%ROOT_NAME%\%NODE_NAME%" /v Model /t REG_SZ /d %MODEL_NAME% /f > %UPD_GUID%
		type %BACKUP_DIR%\updateguid1.bat >> %UPD_GUID%
		del /f/q %BACKUP_DIR%\updateguid1.bat 2>&1
	)
	goto :_End_Recover_License
 )
 
 REM it is strange that if the following block put in ELSE, it will fail
 echo REG ADD "%ROOT_NAME%\%NODE_NAME%" /v Model /t REG_SZ /d %MODEL_NAME% /f > %UPD_GUID%
 echo|set /p=""%VAST_SERVER_DIR%\VMSAdminUtility.exe" -updateguid-nostart " >> %UPD_GUID%
 VMSAdminUtility.exe -getguid >> %UPD_GUID%
 echo|set /p="wmic computersystem where name="%COMPUTERNAME%" call rename name=" >> %UPD_GUID%

 CD /D "%VAST_SERVER_DIR%"
 for /f %%i in ('VMSAdminUtility.exe -getguid') do set GUID=%%i
 CD /D %MY_PATH%
 for /f %%i in ('%SOURCE_PATH1%\md5 -d%GUID%') do set HASH_GUID=%%i
 echo "VIVOTEK-PC-%HASH_GUID%">> %UPD_GUID%
 echo SHUTDOWN -r -t 20 -c "The system will be restored to factory default within 20 seconds." >> %UPD_GUID%

 :_End_Recover_License
 
 exit /b

:CheckCorrectNVRVer
 set _TARGET_VER=%1
 set _LOC_SRC_DIR=
 
 if exist %_TARGET_VER% (
	if exist %_TARGET_VER%\Win7 (
		set _LOC_SRC_DIR=%MY_PATH%%_TARGET_VER%
		goto :_End_CheckCorrectNVRVer 
	)
 ) ELSE (
	if exist \%_TARGET_VER% (
		if exist \%_TARGET_VER%\Win7 (
			set _LOC_SRC_DIR=\%_TARGET_VER%
			goto :_End_CheckCorrectNVRVer
		)
	) ELSE (
		echo. > %diskpart_cmd_file%
		echo list volume >> %diskpart_cmd_file%
		echo exit >> %diskpart_cmd_file%
		del /F/Q %diskpart_out_file% 2>&1
	    call diskpart < %diskpart_cmd_file% | %MY_TEE% %diskpart_out_file%
		
		for /F "tokens=1-6" %%a in ('type %diskpart_out_file% ^| find "Removable"') do (
			if exist %%c:\%_TARGET_VER%\Win7 (
				set _LOC_SRC_DIR=%%c:\%_TARGET_VER%
				goto :_End_CheckCorrectNVRVer
			)
		)		
	)	
 )
 :_End_CheckCorrectNVRVer
 set %2=%_LOC_SRC_DIR%
 
 exit /b


REM the function to find system and backup driver letter, which is the second partition of the same disk of backup drive
REM we must first find backup driver, which is the first partition and should have booticex86.exe, but it might be hidden
REM so we will first check for disk with two partition, and if yes, see if first partition is hidden
REM if yes, just mark hidden flag, and expose it
REM if no or when yes and get exposed, we check if the booticex86.exe exist or not, if yes, this disk is what we want
REM if not, and if the hidden flag is on, just hide it again and try next disk
REM only parameters passed by name should use /A in set
:FindSystemAndBackupDrive
 set diskpart_cmd_file=%TEMP%\diskpart_1.scr
 set diskpart_out_file=%TEMP%\diskpart_out.txt
 set _DiskCount=-1
 set /A _BackupDrive=%1
 set /A _SystemDrive=%2
 set /A _myDISK=%3
 set /A _SystemPartIdx=%4
 set /A _BackupPartIdx=%5
 set /A _backupformated=%6
 set /A _NeedReformat=%7
 
 @call :Print Analyzing system hard disks...
 
 echo. > %diskpart_cmd_file%
 echo list disk >> %diskpart_cmd_file%
 if exist %diskpart_out_file% del /F/Q %diskpart_out_file% 2>&1
 call diskpart < %diskpart_cmd_file% | %MY_TEE% %diskpart_out_file%
 
 for /F %%a in ('type %diskpart_out_file% ^| find "Disk " ^| find /V "###" ^| find /c "Disk"') do set _DiskCount=%%a
 
 if %_DiskCount% LEQ 0 exit /b
 
 set DCNumber=0
 
 :_Loop_disk_FindSystemAndBackupDrive
 echo. > %diskpart_cmd_file%
 echo select disk %DCNumber% >> %diskpart_cmd_file%
 echo detail disk >> %diskpart_cmd_file%
 echo list partition >> %diskpart_cmd_file%
 if exist %diskpart_out_file% del /F/Q %diskpart_out_file% 2>&1
 call diskpart < %diskpart_cmd_file% | %MY_TEE% %diskpart_out_file%

 set _PART_LIST=
 set _PartCount=0
 for /F "tokens=1-2" %%a in ('type %diskpart_out_file% ^| find "Partition " ^| find /V "Volume" ^| find /V "###"') do (
	set _PART_LIST=!_PART_LIST! %%b
	set /A _PartCount=!_PartCount! + 1
 )
 
 REM the second partition should be system, and there should be
 REM VAST_checksum_exf.txt in root of system drive, and also bootmgr under root of system drive
 REM and the first partition lable should be backup
 set _myDISK=%DCNumber%
 
 for %%X in (%_PART_LIST%) do (
	echo. > %diskpart_cmd_file%
	echo select disk %_myDISK% >> %diskpart_cmd_file%
	echo select partition %%X >> %diskpart_cmd_file%
	echo detail partition >> %diskpart_cmd_file%
	if exist %diskpart_out_file% del /F/Q %diskpart_out_file% 2>&1
	call diskpart < %diskpart_cmd_file% | %MY_TEE% %diskpart_out_file%
 
	for /F "tokens=1-6" %%a in ('type %diskpart_out_file% ^| find "*" ^| find "NTFS"') do (
		for /F "tokens=1-5" %%A in ('vol %%d: 2^>^&1 ^| find "Serial Number"') do (
			if %%E==%SYS_VOL_ID_P2% (
				if exist %%d:\VAST_checksum_exf.txt (
					if exist %%d:\bootmgr (
						set _SystemDrive=%%d
						set _SystemPartIdx=%%X
						goto _Backup_Part_Comp
					)
				)
			)
		)		
	)
 )

 :_Not_Found
 REM not found yet, so we try next disk
 set /a DCNumber=%DCNumber%+1
 if %DCNumber% LSS %_DiskCount% goto _Loop_disk_FindSystemAndBackupDrive
 exit /b

 :_Backup_Part_Comp
 REM check second if it is backup drive
 REM first, we must ensure the system is assign as letter C, if not, we got to change it
 if /I NOT %_SystemDrive%==C (
	call :UpdateSystemToC %_myDISK% %_SystemPartIdx%
	set _SystemDrive=C
 )
 
 REM user create more partitions, so we will jsut remove all the partition
 if %_PartCount% GTR 2 (
	@call :Print Ooops, backup drive now contain multiple partitions, got to remove them
	echo. > %diskpart_cmd_file%
	echo select disk %_myDISK% >> %diskpart_cmd_file%
	for %%X in (%_PART_LIST%) do (
		if NOT %%X==%_SystemPartIdx% (
			echo select partition %%X >> %diskpart_cmd_file%
			echo delete partition >> %diskpart_cmd_file%
		)
	)
	call diskpart < %diskpart_cmd_file% 2>&1 
	set _PartCount=1
 )

 REM this means the backup partition doest not exist 
 REM we must create a new partition for it
 if %_PartCount% EQU 1 (
	echo. > %diskpart_cmd_file%
	echo select disk %_myDISK% >> %diskpart_cmd_file%
	echo create partition primary >> %diskpart_cmd_file%
	echo detail partition >> %diskpart_cmd_file%
	if exist %diskpart_out_file% del /F/Q %diskpart_out_file% 2>&1
	call diskpart < %diskpart_cmd_file% 2>&1 | %MY_TEE% %diskpart_out_file%
	
	for /F "tokens=1-2" %%a in ('type %diskpart_out_file% ^| find "Partition" ^| find /V "Volume"') do set _BackupPartIdx=%%b
 ) ELSE (
	for %%X in (%_PART_LIST%) do (
		if NOT %%X==%_SystemPartIdx% set _BackupPartIdx=%%X
	)
 )
 
 REM here the assign will automatically assign backup partition to an letter, and if it is already mount, will be overwrite
 REM that's OK for us, because we don't care which letter is it assign
 REM and in such case, we only care about the partition type and the letter will be in fourth tokens
 echo. > %diskpart_cmd_file%
 echo select disk %_myDISK% >> %diskpart_cmd_file%
 echo select partition %_BackupPartIdx% >> %diskpart_cmd_file%
 echo set id=0C override >> %diskpart_cmd_file%
 echo assign>> %diskpart_cmd_file%
 echo filesystems >> %diskpart_cmd_file%
 echo detail partition >> %diskpart_cmd_file%
 if exist %diskpart_out_file% del /F/Q %diskpart_out_file% 2>&1
 call diskpart < %diskpart_cmd_file% 2>&1 | %MY_TEE% %diskpart_out_file%
 
 REM filesystems will appear first, so we just find the first Type: would be the file systems of the partition
 for /F "tokens=1-4" %%a in ('type %diskpart_out_file% ^| find "*"') do (
	set _BackupDrive=%%d
	for /F "tokens=1-5" %%A in ('vol %%d: 2^>^&1 ^| find "Serial Number"') do (
		if %%E==%BKP_VOL_ID% goto :End_Chk_Format
	)
	set _backupformated=1
 )

 :End_Chk_Format
 set _FOUND=0
 for /F "tokens=1-4" %%a in ('type %diskpart_out_file% ^| find "Type"') do (
	if NOT !_FOUND!==1 (
		set _FOUND=1
		if /I NOT %%c==FAT32 (
			set _NeedReformat=1
			set _backupformated=1
		)
		goto :_Found_Backup_Drive
	)
 )
 
 :_Found_Backup_Drive
 set %1=%_BackupDrive%
 set %2=%_SystemDrive%
 set %3=%_myDISK%
 set %4=%_SystemPartIdx%
 set %5=%_BackupPartIdx%
 set %6=%_backupformated%
 set %7=%_NeedReformat%
 
 @call :Print OK, system driver letter is %_SystemDrive%, and Backup driver letter is %_BackupDrive%.
 if %_backupformated%==1 echo The backup driver is accidently formated!
 if %_NeedReformat%==1 echo Need to reformat the disk
 @call :Print

 exit /b
 
:Print
 @if [%1]==[] (
	@echo.
	@echo. 1>&2
 ) ELSE (
	@echo %*
	@echo %* 1>&2
 )
 @exit /b

:UpdateSystemToC
 set _SysDrive=%1
 set _ThePART=%2
 set _AVA_LETTER=Z
 set _VOLUME_ID=-1
 
 for %%a in (Z Y X W V U T S R Q P O N M L K J I H G F E D C) DO @if not exist %%a: (
	set _AVA_LETTER=%%a
	goto _Got_Letter
 )
 
 :_Got_Letter
 
 echo. > %diskpart_cmd_file%
 echo list volume >> %diskpart_cmd_file%
 echo exit >> %diskpart_cmd_file%
 del /F/Q %diskpart_out_file% 2>&1
 call diskpart < %diskpart_cmd_file% | %MY_TEE% %diskpart_out_file%
 
 for /F "tokens=1-8" %%a in ('type %diskpart_out_file% ^| find "Volume" ^| find /V "###"') do (
	if /I %%c==c (
		set _VOLUME_ID=%%b
		goto :_End_Volume_ID
	)
 )
 
 :_End_Volume_ID
 echo. > %diskpart_cmd_file%
 
 if NOT %_VOLUME_ID%==-1 (
	echo select volume %_VOLUME_ID% >> %diskpart_cmd_file%
	echo assign letter=%_AVA_LETTER% >> %diskpart_cmd_file%
 )
 echo select disk %_SysDrive% >> %diskpart_cmd_file%
 echo select partition %_ThePART% >> %diskpart_cmd_file%
 echo assign letter=C >> %diskpart_cmd_file%
 echo exit >> %diskpart_cmd_file%
 call diskpart < %diskpart_cmd_file%
 
 exit /b
 
 